Attribute VB_Name = "modTranslator"
'*****************************************************************************
'           
'                            : Barmaley
'                       e-mail: mrbarmaley@list.ru
'                               Dust 2006
'*****************************************************************************
Option Explicit

Private Function FromDEC(Base As Integer, Value As String)

'           
Dim m As String
Dim n As String

On Error GoTo TransErr
    m = Value: n = m
    Do
        m = m \ Base
        Select Case (n - Base * m)
            Case 10: FromDEC = FromDEC + "A"
            Case 11: FromDEC = FromDEC + "B"
            Case 12: FromDEC = FromDEC + "C"
            Case 13: FromDEC = FromDEC + "D"
            Case 14: FromDEC = FromDEC + "E"
            Case 15: FromDEC = FromDEC + "F"
            Case Else: FromDEC = FromDEC & (n - Base * m)
        End Select
    n = m
    Loop While m <> 0
    FromDEC = StrReverse(FromDEC)
Exit Function

TransErr:
    Select Case Err.Number
        Case Else: MsgBox "The translation was not successful. Something went terribly wrong." & vbCrLf & vbCrLf & Err.Description & " #" & Err.Number, vbExclamation, "Translation Module Error": Exit Function
    End Select
End Function

Private Function ToDEC(Base As Integer, Value As String)

'          ,  
Dim m As String
Dim i As Integer

On Error GoTo TransErr
m = StrReverse(Value)
    For i = 1 To Len(m)
        Select Case Mid(m, i, 1)
            Case "A": ToDEC = ToDEC + 10 * Base ^ (i - 1)
            Case "B": ToDEC = ToDEC + 11 * Base ^ (i - 1)
            Case "C": ToDEC = ToDEC + 12 * Base ^ (i - 1)
            Case "D": ToDEC = ToDEC + 13 * Base ^ (i - 1)
            Case "E": ToDEC = ToDEC + 14 * Base ^ (i - 1)
            Case "F": ToDEC = ToDEC + 15 * Base ^ (i - 1)
            Case Else: ToDEC = ToDEC + Val(Mid(m, i, 1)) * Base ^ (i - 1)
        End Select
    Next i
Exit Function

TransErr:
    Select Case Err.Number
        Case Else: MsgBox "The translation was not successful. Something went terribly wrong." & vbCrLf & vbCrLf & Err.Description & " #" & Err.Number, vbExclamation, "Translation Module Error": Exit Function
    End Select
End Function

Function Translation(SourceSys As Integer, DestinationSys As Integer, Value As String)

'   ( Value)      
' ( SourceSys)       ( DestinationSys)
    Translation = FromDEC(DestinationSys, ToDEC(SourceSys, Value))
End Function
